package com.weaver.secondev.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.weaver.ebuilder.datasource.api.entity.ExecuteSqlEntity;
import com.weaver.ebuilder.datasource.api.enums.SourceType;
import com.weaver.ebuilder.datasource.api.service.DataSetService;
import com.weaver.framework.rpc.context.impl.TenantRpcContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Author: calyrex
 * @CreateTime: 2025-04-25
 * @Description: 数据操作工具
 */

@Component
@Slf4j
public class DataOperateUtil {

    @Autowired
    private DataSetService dataSetService;

    public List<String> getDetailTableName(String workflowId) {
        log.info("getDetailFormId start : " + workflowId );
        List<String> tableNameList = new ArrayList();
        String sourceType = String.valueOf(SourceType.LOGIC);
        String groupId = "weaver-basic-schedule-service";
        try {
            String sql = "select table_name from ecology10.dbo.form_table where form_id in (select id from  ecology10.dbo.sub_form where form_id in (select relatekey from ecology10.dbo.wfp_relateform  where workflowid = '"+workflowId+"'))";
            log.info("getDetailFormId sql-->" + sql);
            Map<String, Object> datas = executeForQuery(sourceType, groupId, sql);
//            log.info("getConfig datas-->" + datas);
            if(String.valueOf(datas.get("status")).equals("OK")){
                List<Map<String,Object>> records = (List<Map<String,Object>>)datas.get("records");
                for (int i = 0; i < records.size(); i++) {
                    Map<String, Object> map = records.get(i);
                    String table_name = map.get("table_name").toString();
                    tableNameList.add(table_name);
                }
                return tableNameList;
            }else {
                log.error("getDetailFormId status-->"+ datas.get("status"));
                return tableNameList;
            }
        }catch (Exception e){
            log.error("getDetailFormId e--> ",e);
            return tableNameList;
        }
    }

    public String getDepartmentCode(String departmentId){
        String sql = "select code from eteams.dbo.department where id = " + departmentId;
        String sourceType = String.valueOf(SourceType.LOGIC);
        String groupId = "weaver-hrm-service";
        Map<String, Object> stringObjectMap = executeForQuery(sourceType, groupId, sql);
        if(String.valueOf(stringObjectMap.get("status")).equals("OK")){
            List<Map<String,Object>> records = (List<Map<String,Object>>)stringObjectMap.get("records");
            Map<String, Object> map = records.get(0);
            return map.get("code").toString();
        }else {
            log.error("getDepartmentCode status-->"+ stringObjectMap.get("status"));
            return "";
        }
    }

    public String getJobNum(String jobId){
        String sql = "select job_num from eteams.dbo.job where id = " + jobId;
        String sourceType = String.valueOf(SourceType.LOGIC);
        String groupId = "weaver-hrm-service";
        Map<String, Object> stringObjectMap = executeForQuery(sourceType, groupId, sql);
        if(String.valueOf(stringObjectMap.get("status")).equals("OK")){
            List<Map<String,Object>> records = (List<Map<String,Object>>)stringObjectMap.get("records");
            Map<String, Object> map = records.get(0);
            return map.get("job_num").toString();
        }else {
            log.error("getJobNum status-->"+ stringObjectMap.get("status"));
            return "";
        }
    }

    public String getFileName(String fileId){
        String sql = " select name from fileobj where id = " + fileId;
        String sourceType = String.valueOf(SourceType.LOGIC);
        String groupId = "weaver-file-service";
        Map<String, Object> stringObjectMap = executeForQuery(sourceType, groupId, sql);
        if(String.valueOf(stringObjectMap.get("status")).equals("OK")){
            List<Map<String,Object>> records = (List<Map<String,Object>>)stringObjectMap.get("records");
            Map<String, Object> map = records.get(0);
            return map.get("name").toString();
        }else {
            log.error("getFileName status-->"+ stringObjectMap.get("status"));
            return "";
        }
    }

    public String getFormDataId(String requestid){
        String sql = " select dataid from wfc_form_data where requestid = " + requestid;
        String sourceType = String.valueOf(SourceType.LOGIC);
        String groupId = "weaver-workflow-report-serviceworkflowreport";
        Map<String, Object> stringObjectMap = executeForQuery(sourceType, groupId, sql);
        if(String.valueOf(stringObjectMap.get("status")).equals("OK")){
            List<Map<String,Object>> records = (List<Map<String,Object>>)stringObjectMap.get("records");
            Map<String, Object> map = records.get(0);
            return map.get("dataid").toString();
        }else {
            log.error("getFormDataId status-->"+ stringObjectMap.get("status"));
            return "";
        }
    }

    public String getConfig(String key){
        String sourceType = String.valueOf(SourceType.LOGIC);
        String groupId = "weaver-basic-schedule-service";
        try {
            String sql = "select config_value from ecology10.dbo.uf_config where config_key = '" + key + "'";
//            log.info("getConfig sql-->" + sql);
            Map<String, Object> datas = executeForQuery(sourceType, groupId, sql);
//            log.info("getConfig datas-->" + datas);
            if(String.valueOf(datas.get("status")).equals("OK")){
                List<Map<String,Object>> records = (List<Map<String,Object>>)datas.get("records");
                Map<String, Object> map = records.get(0);
                return map.get("config_value").toString();
            }else {
                log.info("getConfig status-->"+ datas.get("status"));
                return "";
            }
        }catch (Exception e){
            log.info("getConfig e--> ",e);
            return "";
        }
    }
    public Map<String, Object> executeForQuery(String sourceType, String groupId, String sql) {
//        log.info("executeForQuery sourceType-->" + sourceType + ",groupId-->" + groupId + ",sql-->" + sql);
        TenantRpcContext.setTargetTenantKey("temkc46eme");
        ExecuteSqlEntity executeSqlEntity = new ExecuteSqlEntity();
        executeSqlEntity.setSql(cn.hutool.core.codec.Base64.encode(sql));
        executeSqlEntity.setGroupId(groupId); //groupid,可以访问  E10地址/api/datasource/ds/group?sourceType=LOGIC 获取
        executeSqlEntity.setSourceType(SourceType.valueOf(sourceType));
//        log.info("executeForQuery executeSqlEntity-->"+executeSqlEntity.getSql()+"-->"+executeSqlEntity.getGroupId()+"-->"+executeSqlEntity.getSourceType());
        Map<String, Object> datas = dataSetService.executeSql(executeSqlEntity);
        log.info("executeForQuery datas-->" + datas);
        TenantRpcContext.removeTargetTenantKey();
        return datas;
    }

    public static String null2String(String s){
        return s == null ? "" : s;
    }

    public static String null2String(Object o){
        return o == null ? "" : o.toString();
    }

    public static String null2String(String s1,String s2){
        return s1 == null ? (s2 == null ? "" : s2) : s1;
    }
}
